#include <stdio.h>

  /* Fibonaccijevi brojevi - rekurzivno.
     Ispisuje povratne vrijednosti svakog
     poziva, zajedno s rednim brojem poziva.

     Koristi globalni (static) brojac poziva
     koji se automatski inicijalizira na 0
     prilikom deklaracije.
  */

long int broj_poziva;


    /* Rekurzivni Fibonacci. */

long int fib(int n)
{
    long int vrijednost, trenutni;

        /* Povecavamo brojac odmah na ulasku. */
        /* To NIJE dovoljno, jer ce ostali pozivi
           PROMIJENITI taj broj PRIJE ispisa!
           Zato zapamtimo ovaj brojac. */
    ++broj_poziva;
    trenutni = broj_poziva;

    if (n == 0)
        vrijednost = 0;
    else if (n == 1)
        vrijednost = 1;
    else
        vrijednost = fib(n - 1) + fib(n - 2);

    printf(" Povratna vrijednost %ld. poziva je %ld\n",
            trenutni, vrijednost);

    return vrijednost;
}


int main (void)
{
    printf("fib(3) = %ld\n", fib(3));

        /* Prije nastavka, ima smisla
           vratiti broj_poziva na 0. */

    printf("fib(5) = %ld\n", fib(5));

    return 0;
}

/* Ovo ispod je standardni main iz fib_r.

int main(void)
{
    int n;

    printf(" Unesite prirodni broj n: ");
    scanf("%d", &n);
    printf("\n");

    broj_poziva = 0;

    printf(" Fibonaccijev broj  F(%d) = %ld\n", n, fib(n));
    printf(" Broj poziva funkcije fib = %ld\n", broj_poziva);

    return 0;
}

*/
