#include <stdio.h>

  /* Ucitava n i pise broj particija broja n,
     tj. broj rastava broja n u sumu nepadajucih
     prirodnih brojeva.
     Osnovni rekurzivni algoritam zbrajanjem.
     Efikasniji zavrsetak rekurzije.
  */

    /* Globalni brojac rekuzivnih poziva funkcije. */

unsigned int broj_poziva = 0u;

    /* Nadji sve particije broja suma u kojima je prvi (sljedeci)
       pribrojnik barem jednak prvi. */

int particije(int suma, int prvi)
{
    int i, broj = 0;

        /* Povecaj globalni brojac poziva funkcije. */
    ++broj_poziva;

        /* Test suma >= prvi potreban je samo za prvi poziv izvana.
           Ako ocekujemo da je vanjski poziv korektan, onda je
           jednostavno modificirati gornju granicu petlje:
             i <= suma  ->  i <= suma - i
           tako da to vrijedi za sve daljnje pozive. */

        /* Ovdje ocekujemo da je prvi <= suma. Tada ima
           bar jedna particija, ona za i = suma.

           Ta particija je sigurno zavrsena, jer je preostala suma
           za rastav (nakon dodavanja tog pribrojnika) jednaka
           suma - i = 0. Povecaj odmah broj za 1. */

    ++broj;

        /* Rekurzivni pozivi - dodavanje sljedeceg pribrojnika i,
           za i <= suma - i < suma.
           Uociti da je preostala suma - i sigurno pozitivna, tj.
           particija nije gotova (fale pribrojnici). Test na GORNJOJ
           granici i <= suma - i osigurava da je u nastavku rekurzije
           prvi <= suma, tj. da sigurno postoje takve particije
           u kojima je sljedeci pribrojnik barem i. */

    for (i = prvi; i <= suma - i; ++i)
        broj += particije( suma - i, i ) ;
    return broj;
}

int main(void)
{
    int n;

    printf(" Upisi prirodni broj n: ");
    scanf("%d", &n);

    printf("\n Broj particija p(%d) = %d\n",
           n, particije(n, 1) );

    printf("\n Broj poziva funkcije = %u\n",
           broj_poziva);

    return 0;
}
