#include <stdio.h>
#include <stdlib.h>

  /* Ucitava n i pise sve particije broja n,
     tj. sve rastave broja n u sumu nepadajucih
     prirodnih brojeva.
     Na kraju ispisuje i broj particija.
     Osnovni rekurzivni algoritam zbrajanjem.

     Koristi globalno dinamicki alocirano polje
     za pribrojnike u particiji.
  */

    /* Globalni pokazivac na dinamicko polje pribrojnika. */

int *pribr;

    /* Nadji sve particije broja suma u kojima je prvi (sljedeci)
       pribrojnik barem jednak prvi, a br_pribr je broj do tada
       postavljenih pribrojnika u "globalnoj" particiji polaznog broja.
       Za br_pribr > 0, indeks zadnjeg postavljenog pribrojnika u
       polju pribr je br_pribr - 1. */

int particije(int suma, int prvi, int br_pribr)
{
    int i, broj = 0;

    if (suma == 0) {
            /* Ispis particije, ocekujemo br_pribr > 0. */
        printf("  %2d", pribr[0]);
        for (i = 1; i < br_pribr; ++i)
            printf(" + %2d", pribr[i]);
        printf("\n");
        return 1;
    }

        /* else */
    ++br_pribr;
    for (i = prvi; i <= suma; ++i) {
            /* Postavljanje sljedeceg pribrojnika u polje
               i rekurzivni poziv - dodavanje tog pribrojnika */
        pribr[br_pribr - 1] = i;
        broj += particije( suma - i, i, br_pribr ) ;
    }
    return broj;
}

int main(void)
{
    int n;

    printf(" Upisi prirodni broj n: ");
    scanf("%d", &n);

        /* Alokacija polja za pribrojnike. */

    if ((pribr = (int*) malloc(n * sizeof(int))) == NULL)
    {
        printf("Alokacija nije uspjela.\n");
        exit(-1);
    }

    printf("\n Sve particije broja %d su:\n\n", n);
    printf("\n Broj particija p(%d) = %d\n",
           n, particije(n, 1, 0) );

    free(pribr);

    return 0;
}
