#include <stdio.h>
#include <stdlib.h>

    /* Tip za pokazivac na element liste. */

typedef struct _element *lista;

    /* Tip za element liste. */

typedef struct _element {
    int broj;            /* Sadrzaj je broj. */
    lista sljed;         /* Pokazivac na sljedeci */
} element;               /* element u listi. */

/* ======================================================================== */

lista kreiraj_straga(lista prvi, lista *p_zadnji, int broj)
{
        /* Vraca zadnji kroz varijabilni argument. */

    lista zadnji = *p_zadnji;
    lista novi = NULL;
/*
    if ((novi = (lista) malloc(sizeof(element))) == NULL)
*/
    novi = (lista) malloc(sizeof(element));
    if (novi == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(-1);
    }

    novi->broj = broj;
    novi->sljed = NULL;

    if (prvi == NULL)
        prvi = novi;
    else
        zadnji->sljed = novi;

    zadnji = novi;
    *p_zadnji = zadnji;  /* Vrati zadnji! */

    return prvi;
}

/* ======================================================================== */

lista obrisi_prvi_parni(lista prvi)
{
        /* Brise prvi parni element u listi.
           Ako ga nema - ne radi nista. */

    lista preth, pom;

    if (prvi == NULL) return NULL;   /* Ne treba. */

    pom = prvi;
    preth = NULL;    /* Ovdje je nuzno. */

    while (pom != NULL && pom->broj % 2 != 0) {
        preth = pom;
        pom = pom->sljed;
    }

        /* Test jesmo li nasli parnog! */

    if (pom != NULL) {

            /* Ovo ispod je:
                 obrisi_iza(prvi, preth);
               BEZ postavljanja pom (to vec je). */
            /* To radi i za preth == NULL. */

        if (preth == NULL) {    /* pom = prvi; */
            prvi = prvi->sljed;
        }
        else {    /* pom = preth->sljed; */
            preth->sljed = pom->sljed;
        }
        free(pom);
            /* Ne treba pom = NULL; */
    }

    return prvi;
}

/* ======================================================================== */

lista obrisi_listu(lista prvi)
{
    lista pom;
/*
    while (prvi != NULL)
        prvi = obrisi_prvog(prvi);
*/
    while (prvi != NULL) {
        pom = prvi;
        prvi = prvi->sljed;
        free(pom);
    }

    return NULL;    /* <=> return prvi; */
}

/* ======================================================================== */

int broj_elemenata(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed)
        ++brojac;

    return brojac;
}

/* ======================================================================== */

void ispisi_listu(lista prvi)
{
    lista pom;
    int brojac = 0;

    for (pom = prvi; pom != NULL; pom = pom->sljed) {
        printf(" Element %2d, broj = %2d\n",
               ++brojac, pom->broj);
    }

    return;
}

/* ======================================================================== */

int main(void)
{
    lista prvi = NULL;   /* Prazna lista! */
    lista zadnji;
    int broj, i;

        /* Punjenje liste straga. */

    printf("Upisivati redom brojeve (0 = kraj).\n");
    do {
        printf("Sljedeci broj:\n");
        scanf("%d", &broj);
        if (broj != 0)
            prvi = kreiraj_straga(prvi, &zadnji, broj);
    } while (broj != 0);

        /* Ispis broja elemenata i cijele liste. */

    printf(" Broj elemenata u listi = %d\n",
           broj_elemenata(prvi));
    ispisi_listu(prvi);


        /* Brisanje trazenih iz liste. */
        /* 6 puta obrisi prvi parni iz liste. */

    for (i = 1; i <= 6; ++i) {
        prvi = obrisi_prvi_parni(prvi);
        printf("\n Obrisan prvi parni element.\n");
        printf(" Broj elemenata u listi = %d\n",
               broj_elemenata(prvi));
        ispisi_listu(prvi);
    }

        /* Obrisi cijelu listu. */

    prvi = obrisi_listu(prvi);

    return 0;
}
