#include <stdio.h>
#include <stdlib.h>
#include <string.h>

  /* Povratne vrijednosti funkcija
     fscanf, fprintf, sscanf, fgets, fputs. */

int main(int argc, char *argv[])
{
    FILE *ulaz, *izlaz;
    char s[80], *str;
    int len, n_fputs, n_fpr, n, i[3], j;

    if (argc != 3) {    /* nema imena datoteka! */
        fprintf(stderr, "%s: nema imena datoteka!\n",
                argv[0]);
        exit(1);
    }

    if ((ulaz = fopen(argv[1], "r")) == NULL) {
        fprintf(stderr, "Ne mogu citati: %s!\n",
                argv[1]);
        exit(2);
    }

    if ((izlaz = fopen(argv[2], "w")) == NULL) {
        fprintf(stderr, "Ne mogu pisati: %s!\n",
                argv[2]);
        exit(3);
    }

    fprintf(izlaz, "  Ulaz: %s\n", argv[1]);
    fprintf(izlaz, " Izlaz: %s\n", argv[2]);

        /* Citanje brojeva iz datoteke. */

    fprintf(izlaz, "\n");
    fprintf(izlaz, " Citanje brojeva iz datoteke:\n");
    fprintf(izlaz, " ---------------------------\n\n");
    n = fscanf(ulaz, "%d%d%d", &i[0], &i[1], &i[2]);
    n_fpr = fprintf(izlaz, "  fscanf return = %d\n", n);
    fprintf(izlaz, " fprintf return = %d\n", n_fpr);

    if (n >= 0) {
        fprintf(izlaz, "\n Ucitane vrijednosti:");
        for (j = 0; j <= n - 1; ++j)
            fprintf(izlaz, " %d", i[j]);
        fprintf(izlaz, "\n");
    }

        /* Ucitaj liniju teksta s ulaza u string. */

    fprintf(izlaz, "\n");
    fprintf(izlaz, " Citanje stringa i brojeva iz stringa:\n");
    fprintf(izlaz, " ------------------------------------\n\n");
    rewind(ulaz);
    str = fgets(s, 80, ulaz);
    if (str == NULL) {
        fprintf(izlaz, " fgets return = NULL"
                       " (Greska ili EOF na ulazu!)\n");
        fclose(ulaz);
        fclose(izlaz);
        return 0;
    }

        /* Ispisi ulaznu liniju. */

    len = strlen(s);
    fprintf(izlaz, " Ulazna linija (duljina = %d):", len);
    n_fputs = fputs(s, izlaz);
    fprintf(izlaz, "\n");
    fprintf(izlaz, "  fputs return = %d\n", n_fputs);

        /* Citanje brojeva iz stringa. */

    n = sscanf(s, "%d%d%d", &i[0], &i[1], &i[2]);
    fprintf(izlaz, " sscanf return = %d\n", n);

    if (n >= 0) {
        fprintf(izlaz, "\n Ucitane vrijednosti:");
        for (j = 0; j <= n - 1; ++j)
            fprintf(izlaz, " %d", i[j]);
        fprintf(izlaz, "\n");
    }

    fclose(ulaz);
    fclose(izlaz);

    return 0;
}
