#include <stdio.h>
#include <stdlib.h>

    /* Program za kreiranje nesortirane datoteke
       cijelih brojeva. Ta datoteka ce se koristiti
       kao ulaz/izlaz u programima za sortiranje. */

    /* Tip objekata u datoteci je obj_type = int,
       a velicina takvog objekta je obj_size. */

typedef int obj_type;

size_t obj_size = sizeof(obj_type);


void kreiraj_dat(const char *f_name, obj_type x_obj[],
                 size_t n_obj, size_t obj_size)
{
    FILE *f_obj;

    if ((f_obj = fopen(f_name, "wb")) == NULL) {
        fprintf(stderr, "Ne mogu pisati u: %s!\n",
                f_name);
        exit(10);
    }

        /* Pisanje cijelog polja x_obj. */

    if (fwrite(x_obj, obj_size, n_obj, f_obj) != n_obj) {
        fprintf(stderr, "Greska u pisanju.\n");
        exit(11);
    }

    fclose(f_obj);

    return;
}


void ispisi_dat(const char *f_name, size_t obj_size)
{
    FILE *f_obj;
    obj_type x;
    size_t broj_obj = 0;

    if ((f_obj = fopen(f_name, "rb")) == NULL) {
        fprintf(stderr, "Ne mogu citati iz: %s!\n",
                f_name);
        exit(20);
    }

    printf("\n Sadrzaj datoteke %s:\n", f_name);

    while (fread(&x, obj_size, 1, f_obj) == 1) {
        ++broj_obj;
        printf("   zapis %2u: %6d\n",
               broj_obj, x);
    }

    if (ferror(f_obj)) {
        fprintf(stderr, "Greska u citanju.\n");
        exit(21);
    }

    fclose(f_obj);

    return;
}


int main(int argc, char *argv[])
{
    size_t n_obj = 7;
    obj_type x[] = {42, 12, 55, 94, 18, 44, 67};

    if (argc != 2) {    /* Nema imena datoteke! */
        fprintf(stderr, "Uporaba: %s ime_dat\n",
                argv[0]);
        exit(1);
    }

    kreiraj_dat(argv[1], x, n_obj, obj_size);

    ispisi_dat(argv[1], obj_size);

    return 0;
}
